<template>
  <form @submit.prevent class="form">
    <b-field label="Title">
      <b-input v-model="imageDetails.title"></b-input>
    </b-field>
    <b-field label="Description">
      <b-input maxlength="400" type="textarea" v-model="imageDetails.description"></b-input>
    </b-field>
    <b-field label="Add a category">
      <b-select
        placeholder="Select a Category"
        expanded
        v-model="imageDetails.categoriesIds">
        <option v-for="category in categories" :key="category.id" :value="category.id">{{category.title}}</option>
      </b-select>
    </b-field>
    <b-field label="Add some tags">
      <b-taginput
        v-model="imageDetails.tags"
        ellipsis
        placeholder="Add a tag">
      </b-taginput>
    </b-field>
    <p class="control">
      <button class="button is-primary" @click="createImage">Submit</button>
    </p>
  </form>
</template>

<script>
import ALL_CATEGORIES_QUERY from '@/graphql/Category/AllCategories.gql'
import ALL_IMAGES_QUERY from '@/graphql/Image/AllImages.gql'
import CREATE_IMAGE_MUTATION from '@/graphql/Image/CreateImage.gql'
export default {
  props: { image: Object },
  data () {
    return {
      imageDetails: {
        title: '',
        description: '',
        tags: [],
        categoriesIds: []
      },
      categories: []
    }
  },
  created () {
    this.getCategories()
  },
  methods: {
    getCategories () {
      this.$apollo.query({
        query: ALL_CATEGORIES_QUERY
      }).then(({data: { allCategories }}) => { this.categories = allCategories })
    },
    createImage () {
      const userId = localStorage.getItem('apollo-user')
      this.$apollo.mutate({
        mutation: CREATE_IMAGE_MUTATION,
        variables: {
          userId,
          ...this.imageDetails,
          type: this.image.format,
          url: this.image.secure_url,
          path: this.image.path,
          filename: this.image.public_id,
          metadata: this.image.image_metadata
        },
        update: (store, { data: { createImage } }) => {
          // Read the data from our cache for this query.
          const data = store.readQuery({ query: ALL_IMAGES_QUERY })
          // Add our image from the mutation to the beginning
          data.allImages.unshift(createImage)
          // Write our data back to the cache.
          store.writeQuery({ query: ALL_IMAGES_QUERY, data })
        }
      }).then(({data}) => {
        this.$router.push({ name: 'feed' })
      }).catch(error => console.error(error))
    }
  }
}
</script>
